/*
 * CreatureManager Tim Tyler 2000-2000.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   // import java.lang.Math;

   public class CreatureManager extends Object {
   		// stuff...
      int temp, temp2, temp3, temp4, temp5, temp6;
      int agent_counter;
   
      int temp_x, temp_y, temp_radius;
   
      Creature[] creature;
      Creature[] new_array_of_creatures;
   
      int max_number_of_creatures = 1;
      int number_of_creatures;
   
      Creature temp_creature;
      Creature current_creature;
   
      Entity temp_entity;
      Entity temp_entity2;
   
      EntityLink temp_link;
      EntityLink temp_link2;
   
      Hortensius32Fast rnd = new Hortensius32Fast();
   
      final public void initial() {
         max_number_of_creatures = 1;
         number_of_creatures = 0;
         creature = new Creature[max_number_of_creatures];
      }
   
   
      // maximum value check....
      final Creature add() { // Creature e1, Creature e2, int l, int e) {
         // debug("Number of creatures:" + number_of_creatures);
      
         if (number_of_creatures >= max_number_of_creatures) {
            makeMoreCreatures();
         }
      
         if (creature[number_of_creatures] == null) {
            temp_creature = new Creature();
            creature[number_of_creatures++] = temp_creature;
         }
         else
         {
            temp_creature = creature[number_of_creatures++];
            temp_creature.set();
         }
      
         return temp_creature;
      }
   
   
      // maximum value check....
      final void setCreature() {
         if (number_of_creatures >= max_number_of_creatures) {
            makeMoreCreatures();
         }
      
         if (creature[number_of_creatures] == null) {
            creature[number_of_creatures++] = new Creature();
         }
         else
         {
            creature[number_of_creatures++].set();
         }
      }
   
   
      final void makeMoreCreatures() {
         max_number_of_creatures++;
      
         new_array_of_creatures = new Creature[max_number_of_creatures];
      
         for (temp = number_of_creatures; --temp >= 0; ) {
            new_array_of_creatures[temp] = creature[temp];
         }
      
         creature = new_array_of_creatures;
      }
   
   
      final void duplicate(Creature c, PrivateWorld pw) {
         if (c != null) {
            if ((c.status & Creature.DEAD) == 0) {
               current_creature = add(); // new creature...
            
               current_creature.egg_attached = c.egg_attached;
               current_creature.egg = c.egg;
            
               // dubious...
               // current_creature = creature[number_of_creatures - 1]; // pointer to new creature...
               current_creature.private_world = pw; // c.private_world;
            
               for (temp = 0; temp < c.number_of_entities; temp++) {
                  temp_entity = c.entity_list[temp];
               
               // this never happens...
                  // if ((temp_entity.status & Entity.HAS_INNER_WORLD) != 0) {
                     // debug("WOW");
                  // }
               
                  temp_entity2 = pw.copy(temp_entity);
               
                  temp_entity2.setInitialSize((byte)2, temp_entity.target_diameter);
                  // temp_entity2.creature = current_creature;  // not needed...
                  current_creature.add(temp_entity2);
                  if (temp_entity == c.read_entity) {
                     current_creature.read_entity = temp_entity2;
                  }
               
                  if (temp_entity == c.write_entity) {
                     current_creature.write_entity = temp_entity2;
                  }
               }
            
               // debug("NOLK:" + pw.link_manager.number_of_links); // zero OK...
               for (temp = 0; temp < c.number_of_entities; temp++) {
                  temp_entity = c.entity_list[temp];
                  temp3 = temp_entity.list_of_links.number_of_links;
               
                  // debug("NOLK:" + temp3); // this can be zero!
               
                  for (temp2 = temp3; --temp2 >= 0; ) {
                     temp_link = temp_entity.list_of_links.link[temp2];
                     temp4 = c.getEntityNumber(temp_link.entity1);
                     temp5 = c.getEntityNumber(temp_link.entity2);
                  
                     // if (temp4 < 0) debug("temp4 < 0 - egg?"); // NOT OK - this should be alive still...
                     // if (temp5 < 0) debug("temp5 < 0 -- egg?"); // unless it's an attached egg...
                  
                     if (temp4 >= 0) { // part of the problem...
                        if (temp5 >= 0) { // part of the problem...
                           if (!pw.link_manager.thereIsALinkBetween(current_creature.entity_list[temp4], current_creature.entity_list[temp5])) {
                              temp_link2 = pw.link_manager.setLink(current_creature.entity_list[temp4],current_creature.entity_list[temp5], temp_link.lower_length_limit, temp_link.elasticity, temp_link.colour, temp_link.status);
                              temp_link2.setInitialLength(6, temp_link.target_length);
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   
   
      final int getNumberOfCreature(Creature c) {
         for (temp = number_of_creatures; --temp >= 0; ) {
            if (creature[temp] == c) {
               return temp;
            }
         }
      
         return -1;
      }
   
   
      final void killNumberedCreature(int n) {              
         if ((n >= 0) && (n < number_of_creatures)) {
            temp_creature = creature[n];
            if ((temp_creature.status & Creature.DEAD) == 0) {
               // temp_creature.status |= Creature.DEAD; // you need to make sure you don't try to kill a creature twice...
            	// need to manually go through and destroy all references to this creature...
               temp_creature.markAsKilled();
            
               creature[n] = creature[number_of_creatures - 1];
               creature[--number_of_creatures] = temp_creature;
            
               // debug("CREATURE NUMBER(" + n + ") KILLED - Now NOC = " + number_of_creatures);
            }
            else
            {
               // never fires...
               debug("ATTEMPT TO KILL DEAD CREATURE(" + n + ") ERROR - NOC:" + number_of_creatures);
            }
         }
         else
         {
            // never fires...
            debug("CREATURE NUMBER(" + n + ") OUT OF BOUNDS - NOC:" + number_of_creatures);
         }
      }
   
   
      final void killSpecifiedCreature(Creature l) {
         if (l != null) {
            if ((l.status & Creature.DEAD) == 0) {
               temp = getNumberOfCreature(l);
               killNumberedCreature(temp);
            }
            else
            {
               // never fires...
               debug("ATTEMPT TO KILL DEAD CREATURE ... ERROR - NOC:" + number_of_creatures);
            }
         }
         //else
         //{
            // fires...
            //debug("NULL CREATURE KILLED!" + number_of_creatures);
         //}
      }
   
   
      final void killAllCreatures() { // Creature e) {
         for (temp = number_of_creatures; --temp >= 0; ) {
            temp_creature = creature[temp];
         
            killCreature(temp_creature.write_entity);
         }
      }
   
   
      final void killCreature(Entity e) {
         temp_creature = e.creature;
      
         e.simplyKill();
         killSpecifiedCreature(temp_creature);
      }
   
   
      final void infectCreature(Entity e1, Entity e2) {
         temp_creature = e1.creature;
      
         Entity.infectByContact(e1, e2);
      
         killSpecifiedCreature(temp_creature);
      }
   
   /*
      final void moveCreaturesBetweenWorlds(PrivateWorld pw_from, PrivateWorld pw_to, int ien) {
         for (temp = number_of_creatures; --temp >= 0; ) {
            temp_creature = creature[temp];
         
            if (temp_creature.private_world == pw_from) {
               temp_creature.private_world = pw_to;
            
            	// move *all* the entities across (sigh)...
            	// *must* go forwards...
               for (temp2 = 0; temp2 < temp_creature.number_of_entities; temp2++) {
                  temp_entity = temp_creature.entity_list[temp2];
                  temp4 = pw_from.getEntityNumber(temp_entity);
                  temp_creature.entity_list[temp2] = pw_to.agent[temp4 + ien];
                  if (temp_creature.entity_list[temp2] == null) {
                     debug("problems already"); // doesn't fire...
                  }
               }	
            
               temp_creature.read_entity = temp_creature.entity_list[0]; // phew!?! :-(
               temp_creature.write_entity = temp_creature.entity_list[0]; // phew!?! :-(
            }
         } 
      }
   */
   
   
      final void moveCreaturesBetweenWorlds2(PrivateWorld pw_from, PrivateWorld pw_to) {
         for (temp = number_of_creatures; --temp >= 0; ) {
            temp_creature = creature[temp];
         
            if (temp_creature.private_world == pw_from) {
               temp_creature.private_world = pw_to;
            }
         } 
      }
   
   
      final void debug(String o) {
         System.out.println(o);
      }
   
   }
