/*
 * EntityManager Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;

   public class EntityManager extends PrivateWorld {
      Entity_Leader[] new_array_of_leaders;
      Entity_Leader[] leader;
   
      EntityGrid entity_grid;
   
      // static stuff...
      static EntityList list;
   
      static int gcd;
      static int piston = 1000;
   
      static int new_bin_x;
      static int new_bin_y;
   
      static Entity_Leader temp_leader;
   
      static Entity temp3_entity;
      static Entity temp4_entity;
      static Entity temp5_entity;
      static Entity temp6_entity;
   
      static int target_number_of_agents = 600;
   
      static int target_number_of_leaders = 1;
      static int number_of_leaders        = 0;
   
      static int max_number_of_links = 10;
      static int number_of_links = 1;
   
      static int towards_leader;
      static int acc_of_leader;
      static int gravity;
   
      static byte general_eggsize;
      static byte general_size;
   
      static int number_of_ship;
   
      static Ships ship;
   
      EntityManager() {
         super();
      }
   
   
      final public void initial_reset() {
         max_number_of_agents = 1;
         number_of_agents = 0;
      
         number_of_leaders = 0;
      
         Entity.initial();
      
         agent = new Entity[max_number_of_agents];
         leader = new Entity_Leader[number_of_leaders];
      }
   
   
      final public void initial() {
         set(null);
         initial_reset();
      
         // link_manager = new LinkManager();
      
         if (Shoals.gas_sim) {
            target_number_of_agents = 600;
            target_number_of_leaders = 1;
            towards_leader = 0x0; // << shift;
            acc_of_leader = 0x0;
            gravity = 0;
            minimum_magnitude = 10 << 6;
            general_eggsize = 30;
            Entity.max_velocity = 50 << 5;	
            Entity.friction_strength = 5;
         }   	
         else
         {
            target_number_of_leaders = 1;
            towards_leader = 200 << 8;
            acc_of_leader = 80;
            general_eggsize = 48;
            // general_size = 30;
            gravity = 0;
            minimum_magnitude = 10 << 6;
            Entity.max_velocity = 500 << 5;
            Entity.friction_strength = 10;
         }
      
         Shoals_Input.loadFromString(getCreatureDescription(),Shoals.entity_manager,0,0,256);
      
         Shoals_Input.addFromString(getCreatureDescription(),Shoals.entity_manager,200 << shift,200 << shift,256);
      
         Shoals_Input.addFromString(getCreatureDescription(),Shoals.entity_manager,400 << shift,400 << shift,256);
      
         number_of_leaders = 1;
      
         leader = new Entity_Leader[number_of_leaders];
      
         for (temp = 0; temp < number_of_leaders; temp++) {
            leader[temp] = new Entity_Leader(rnd.nextInt(Shoals_Canvas.gsx) << shift,rnd.nextInt(Shoals_Canvas.gsy) << shift, rnd.nextInt());
            leader[temp].status |= Entity.IMMORTAL | Entity.IMMUNE;
         }
      
         // addNewAgent(100, 100, (char)79, (byte)16, (byte)14, Entity.DEADLY | Entity.IMMORTAL | Entity.DRAG | Entity.ALWAYS_CIRCULAR);
      
         // addNewAgent(0, 400 << 8, (char)79, (byte)48, (byte)13, Entity.DEADLY | Entity.IMMORTAL | Entity.IMMUNE); // sink...
         //addNewAgent(0, 400 << 8, (char)79, (byte)48, (byte)13, Entity.DEADLY | Entity.IMMORTAL | Entity.IMMUNE); // sink...
         //addNewAgent(0, 400 << 8, (char)79, (byte)48, (byte)13, Entity.DEADLY | Entity.IMMORTAL | Entity.IMMUNE); // sink...
      
      
         // general_size = 39; // getEntitySize();
         general_size = getEntitySize();
      // setGlobalSize(general_size);
      
         temp_agent = addNewAgent(0, 0, (char)511, general_size, (byte)16, Entity.SOURCE | Entity.IMMORTAL | Entity.IMMUNE); // source...
         temp_agent.dx = 1024;
         temp_agent.dy = 1024;
      
         temp_agent = addNewAgent(200 << 8, 0, (char)63, general_size, (byte)16, Entity.SOURCE | Entity.IMMORTAL | Entity.IMMUNE); // source...
         temp_agent.dy = 2048;
         temp_agent = addNewAgent(300 << 8, 0, (char)507, general_size, (byte)16, Entity.SOURCE | Entity.IMMORTAL | Entity.IMMUNE); // source...
         temp_agent.dy = 2048;
         temp_agent = addNewAgent(0, 200 << 8, (char)63, general_size, (byte)16, Entity.SOURCE | Entity.IMMORTAL | Entity.IMMUNE); // source...
         temp_agent.dx = 2048;
         temp_agent = addNewAgent(0, 300 << 8, (char)507, general_size, (byte)16, Entity.SOURCE | Entity.IMMORTAL | Entity.IMMUNE); // source...
         temp_agent.dx = 2048;
      
      }
   
   
      final public String getCreatureDescription() {
         switch (Shoals.initial_type) {
         
            case Shoals._START_LARGE:
               return "Creature Key_Node:0 Data:0 Agent X:65814 Y:52932 D:39 C:63 Agent X:98858 Y:55333 D:39 Agent X:72149 Y:61119 D:39 C:63 Agent X:43743 Y:67148 D:39 Agent X:35995 Y:58383 D:39 Agent X:102881 Y:65995 D:39 Agent X:63486 Y:62586 D:39 C:507 Agent X:76904 Y:52931 D:39 C:507 Agent X:92224 Y:63454 D:39 C:63 Agent X:81959 Y:62722 D:39 C:507 Agent X:87818 Y:54102 D:39 C:63 Agent X:60201 Y:44441 D:39 C:63 Agent X:52976 Y:63615 D:39 C:63 Agent X:56550 Y:55001 D:39 C:507 Agent X:45726 Y:56285 D:39 C:63 Agent X:93322 Y:45408 D:39 Agent X:54309 Y:35724 D:39 C:63 Agent X:23422 Y:42470 D:39 Agent X:29796 Y:50430 D:39 Agent X:87424 Y:35541 D:39 Agent X:42660 Y:35585 D:39 C:507 Agent X:71187 Y:44452 D:39 C:507 Agent X:76528 Y:35443 D:39 C:63 Agent X:65670 Y:35494 D:39 C:507 Agent X:82364 Y:44416 D:39 C:63 Agent X:39818 Y:47863 D:39 C:63 Agent X:33370 Y:39748 D:39 C:63 Agent X:50348 Y:46344 D:39 C:507 Link One:24 Two:7 ULL:40 E:160 C:511 Link One:7 Two:2 ULL:40 E:160 C:511 Link One:6 Two:0 ULL:40 E:160 C:511 Link One:0 Two:21 ULL:40 E:160 C:511 Link One:21 Two:22 ULL:40 E:160 C:511 Link One:23 Two:11 ULL:40 E:160 C:511 Link One:11 Two:13 ULL:40 E:160 C:511 Link One:13 Two:12 ULL:40 E:160 C:511 Link One:3 Two:14 ULL:40 E:160 C:511 Link One:14 Two:27 ULL:40 E:160 C:511 Link One:27 Two:16 ULL:40 E:160 C:511 Link One:20 Two:25 ULL:40 E:160 C:511 Link One:25 Two:4 ULL:40 E:160 C:511 Link One:18 Two:26 ULL:40 E:160 C:511 Link One:26 Two:17 ULL:40 E:160 C:511 Link One:17 Two:18 ULL:40 E:160 C:511 Link One:18 Two:25 ULL:40 E:160 C:511 Link One:10 Two:24 ULL:40 E:160 C:511 Link One:13 Two:27 ULL:40 E:160 C:511 Link One:7 Two:21 ULL:40 E:160 C:511 Link One:11 Two:0 ULL:40 E:160 C:511 Link One:5 Two:1 ULL:40 E:160 C:511 Link One:1 Two:10 ULL:40 E:160 C:511 Link One:1 Two:15 ULL:40 E:160 C:511 Link One:1 Two:8 ULL:40 E:160 C:511 Link One:15 Two:10 ULL:40 E:160 C:511 Link One:10 Two:9 ULL:40 E:160 C:511 Link One:19 Two:24 ULL:40 E:160 C:511 Link One:3 Two:4 ULL:40 E:160 C:511 Link One:4 Two:14 ULL:40 E:160 C:511 Link One:15 Two:24 ULL:40 E:160 C:511 Link One:24 Two:22 ULL:40 E:160 C:511 Link One:15 Two:19 ULL:40 E:160 C:511 Link One:19 Two:22 ULL:40 E:160 C:511 Link One:22 Two:23 ULL:40 E:160 C:511 Link One:23 Two:21 ULL:40 E:160 C:511 Link One:24 Two:21 ULL:40 E:160 C:511 Link One:21 Two:11 ULL:40 E:160 C:511 Link One:11 Two:16 ULL:40 E:160 C:511 Link One:23 Two:16 ULL:40 E:160 C:511 Link One:16 Two:20 ULL:40 E:160 C:511 Link One:20 Two:27 ULL:40 E:160 C:511 Link One:27 Two:11 ULL:40 E:160 C:511 Link One:27 Two:25 ULL:40 E:160 C:511 Link One:25 Two:26 ULL:40 E:160 C:511 Link One:26 Two:20 ULL:40 E:160 C:511 Link One:25 Two:14 ULL:40 E:160 C:511 Link One:10 Two:8 ULL:40 E:160 C:511 Link One:18 Two:4 ULL:40 E:160 C:511 Link One:5 Two:8 ULL:40 E:160 C:511 Link One:8 Two:9 ULL:40 E:160 C:511 Link One:9 Two:7 ULL:40 E:160 C:511 Link One:10 Two:7 ULL:40 E:160 C:511 Link One:7 Two:0 ULL:40 E:160 C:511 Link One:0 Two:2 ULL:40 E:160 C:511 Link One:9 Two:2 ULL:40 E:160 C:511 Link One:2 Two:6 ULL:40 E:160 C:511 Link One:6 Two:13 ULL:40 E:160 C:511 Link One:13 Two:0 ULL:40 E:160 C:511 Link One:13 Two:14 ULL:40 E:160 C:511 Link One:14 Two:12 ULL:40 E:160 C:511 Link One:12 Two:6 ULL:40 E:160 C:511 Link One:12 Two:3 ULL:40 E:160 C:511 ";
            
            case Shoals._START_MEDIUM:
               return "Creature Key_Node:0 Data:0 Agent X:49526 Y:42870 D:29 C:507 Agent X:24454 Y:15651 D:29 Agent X:56529 Y:47191 D:29 C:63 Agent X:22079 Y:23336 D:29 Agent X:57916 Y:31620 D:29 C:63 Agent X:64230 Y:44711 D:29 Agent X:21359 Y:31897 D:29 Agent X:47776 Y:51038 D:29 C:507 Agent X:55033 Y:55284 D:29 C:63 Agent X:42051 Y:37661 D:29 C:507 Agent X:41321 Y:45814 D:29 C:507 Agent X:44146 Y:21630 D:29 C:507 Agent X:43935 Y:29681 D:29 C:507 Agent X:35076 Y:42527 D:29 C:63 Agent X:61080 Y:60584 D:29 Agent X:28840 Y:28481 D:29 C:63 Agent X:51175 Y:26809 D:29 C:507 Agent X:63098 Y:53542 D:29 Agent X:31535 Y:12239 D:29 C:63 Agent X:64936 Y:36066 D:29 Agent X:30235 Y:19773 D:29 C:63 Agent X:24770 Y:7542 D:29 Agent X:35659 Y:33353 D:29 C:63 Agent X:36675 Y:24663 D:29 C:63 Agent X:28284 Y:36677 D:29 C:63 Agent X:56601 Y:40444 D:29 C:63 Agent X:50795 Y:34337 D:29 C:507 Agent X:38156 Y:17524 D:29 C:63 Link One:16 Two:26 ULL:30 E:160 C:511 Link One:26 Two:0 ULL:30 E:160 C:511 Link One:22 Two:9 ULL:30 E:160 C:511 Link One:12 Two:22 ULL:30 E:160 C:511 Link One:26 Two:4 ULL:30 E:160 C:511 Link One:26 Two:12 ULL:30 E:160 C:511 Link One:16 Two:12 ULL:30 E:160 C:511 Link One:15 Two:24 ULL:30 E:160 C:511 Link One:0 Two:9 ULL:30 E:160 C:507 Link One:13 Two:22 ULL:30 E:160 C:63 Link One:19 Two:5 ULL:30 E:160 C:511 Link One:23 Two:12 ULL:30 E:160 C:511 Link One:1 Two:3 ULL:30 E:160 C:511 Link One:19 Two:25 ULL:30 E:160 C:511 Link One:3 Two:6 ULL:30 E:160 C:511 Link One:15 Two:23 ULL:30 E:160 C:511 Link One:1 Two:18 ULL:30 E:160 C:511 Link One:5 Two:25 ULL:30 E:160 C:511 Link One:17 Two:2 ULL:30 E:160 C:511 Link One:22 Two:24 ULL:30 E:160 C:511 Link One:18 Two:27 ULL:30 E:160 C:63 Link One:6 Two:24 ULL:30 E:160 C:511 Link One:9 Two:12 ULL:30 E:160 C:511 Link One:12 Two:11 ULL:30 E:160 C:511 Link One:27 Two:23 ULL:30 E:160 C:511 Link One:26 Two:25 ULL:30 E:160 C:511 Link One:25 Two:4 ULL:30 E:160 C:511 Link One:20 Two:23 ULL:30 E:160 C:511 Link One:8 Two:14 ULL:30 E:160 C:511 Link One:2 Two:8 ULL:30 E:160 C:511 Link One:3 Two:15 ULL:30 E:160 C:511 Link One:8 Two:7 ULL:30 E:160 C:511 Link One:15 Two:22 ULL:30 E:160 C:511 Link One:2 Two:5 ULL:30 E:160 C:511 Link One:13 Two:9 ULL:30 E:160 C:511 Link One:21 Two:1 ULL:30 E:160 C:511 Link One:1 Two:20 ULL:30 E:160 C:511 Link One:27 Two:11 ULL:30 E:160 C:511 Link One:17 Two:8 ULL:30 E:160 C:511 Link One:14 Two:17 ULL:30 E:160 C:511 Link One:9 Two:10 ULL:30 E:160 C:511 Link One:2 Two:25 ULL:30 E:160 C:511 Link One:25 Two:0 ULL:30 E:160 C:511 Link One:23 Two:11 ULL:30 E:160 C:511 Link One:11 Two:16 ULL:30 E:160 C:511 Link One:20 Two:18 ULL:30 E:160 C:511 Link One:17 Two:5 ULL:30 E:160 C:511 Link One:3 Two:20 ULL:30 E:160 C:511 Link One:24 Two:13 ULL:30 E:160 C:511 Link One:20 Two:27 ULL:30 E:160 C:511 Link One:21 Two:18 ULL:30 E:160 C:511 Link One:9 Two:26 ULL:30 E:160 C:511 Link One:0 Two:10 ULL:30 E:160 C:507 Link One:4 Two:16 ULL:30 E:160 C:511 Link One:20 Two:15 ULL:30 E:160 C:511 Link One:13 Two:10 ULL:30 E:160 C:511 Link One:23 Two:22 ULL:30 E:160 C:511 Link One:10 Two:7 ULL:30 E:160 C:507 Link One:4 Two:19 ULL:30 E:160 C:511 Link One:7 Two:0 ULL:30 E:160 C:511 Link One:6 Two:15 ULL:30 E:160 C:511 Link One:7 Two:2 ULL:30 E:160 C:511 Link One:0 Two:2 ULL:30 E:160 C:511 ";
            
            case Shoals._START_SMALL:
               return "Creature Key_Node:0 Data:0  Agent X:44233 Y:27473 D:21 C:507 Agent X:39489 Y:33883 D:21 C:507 Agent X:34544 Y:21404 D:21 C:507 Agent X:16810 Y:46883 D:21 Agent X:28229 Y:20413 D:21 C:63 Agent X:29655 Y:48753 D:21 Agent X:33835 Y:32662 D:21 C:63 Agent X:31351 Y:26515 D:21 C:63 Agent X:24360 Y:36464 D:21 C:63 Agent X:29327 Y:37449 D:21 C:63 Agent X:44386 Y:15647 D:21 Agent X:35709 Y:38604 D:21 C:63 Agent X:25593 Y:42751 D:21 C:507 Agent X:33258 Y:16003 D:21 Agent X:18032 Y:36010 D:21 C:63 Agent X:25141 Y:25493 D:21 C:507 Agent X:14156 Y:40844 D:21 C:63 Agent X:31824 Y:42775 D:21 C:63 Agent X:47340 Y:22176 D:21 C:63 Agent X:40688 Y:22023 D:21 C:507 Agent X:21083 Y:31493 D:21 C:507 Agent X:22681 Y:47814 D:21 Agent X:11020 Y:45769 D:21 Agent X:38664 Y:16746 D:21 Agent X:20720 Y:42347 D:21 C:507 Agent X:37743 Y:27378 D:21 C:63 Agent X:49822 Y:16285 D:21 Agent X:27282 Y:31343 D:21 C:63 Link One:18 Two:0 ULL:22 E:160 C:511 Link One:16 Two:14 ULL:22 E:160 C:63 Link One:20 Two:15 ULL:22 E:160 C:511 Link One:26 Two:10 ULL:22 E:160 C:511 Link One:5 Two:17 ULL:22 E:160 C:511 Link One:27 Two:20 ULL:22 E:160 C:511 Link One:12 Two:9 ULL:22 E:160 C:511 Link One:3 Two:24 ULL:22 E:160 C:511 Link One:24 Two:16 ULL:22 E:160 C:511 Link One:6 Two:1 ULL:22 E:160 C:511 Link One:27 Two:9 ULL:22 E:160 C:511 Link One:14 Two:8 ULL:22 E:160 C:511 Link One:25 Two:6 ULL:22 E:160 C:507 Link One:15 Two:7 ULL:22 E:160 C:511 Link One:12 Two:17 ULL:22 E:160 C:511 Link One:2 Two:4 ULL:22 E:160 C:511 Link One:11 Two:9 ULL:22 E:160 C:63 Link One:7 Two:4 ULL:22 E:160 C:511 Link One:25 Two:1 ULL:22 E:160 C:507 Link One:19 Two:2 ULL:22 E:160 C:511 Link One:12 Two:8 ULL:22 E:160 C:511 Link One:14 Two:20 ULL:22 E:160 C:511 Link One:10 Two:23 ULL:22 E:160 C:511 Link One:7 Two:2 ULL:22 E:160 C:511 Link One:3 Two:16 ULL:22 E:160 C:511 Link One:6 Two:27 ULL:22 E:160 C:511 Link One:7 Two:25 ULL:22 E:160 C:511 Link One:8 Two:27 ULL:22 E:160 C:511 Link One:0 Two:19 ULL:22 E:160 C:511 Link One:4 Two:15 ULL:22 E:160 C:511 Link One:24 Two:8 ULL:22 E:160 C:511 Link One:1 Two:0 ULL:22 E:160 C:507 Link One:2 Two:25 ULL:22 E:160 C:511 Link One:24 Two:12 ULL:22 E:160 C:511 Link One:21 Two:24 ULL:22 E:160 C:511 Link One:13 Two:23 ULL:22 E:160 C:511 Link One:3 Two:21 ULL:22 E:160 C:511 Link One:10 Two:19 ULL:22 E:160 C:511 Link One:22 Two:16 ULL:22 E:160 C:511 Link One:25 Two:19 ULL:22 E:160 C:511 Link One:17 Two:11 ULL:22 E:160 C:511 Link One:11 Two:1 ULL:22 E:160 C:511 Link One:7 Two:27 ULL:22 E:160 C:511 Link One:9 Two:17 ULL:22 E:160 C:511 Link One:19 Two:23 ULL:22 E:160 C:511 Link One:13 Two:2 ULL:22 E:160 C:511 Link One:6 Two:7 ULL:22 E:160 C:511 Link One:21 Two:5 ULL:22 E:160 C:511 Link One:10 Two:18 ULL:22 E:160 C:511 Link One:23 Two:2 ULL:22 E:160 C:511 Link One:15 Two:27 ULL:22 E:160 C:511 Link One:24 Two:14 ULL:22 E:160 C:511 Link One:21 Two:12 ULL:22 E:160 C:511 Link One:11 Two:6 ULL:22 E:160 C:511 Link One:18 Two:26 ULL:22 E:160 C:511 Link One:22 Two:3 ULL:22 E:160 C:511 Link One:8 Two:20 ULL:22 E:160 C:511 Link One:4 Two:13 ULL:22 E:160 C:511 Link One:9 Two:6 ULL:22 E:160 C:511 Link One:0 Two:25 ULL:22 E:160 C:511 Link One:19 Two:18 ULL:22 E:160 C:511 Link One:5 Two:12 ULL:22 E:160 C:511 Link One:8 Two:9 ULL:22 E:160 C:511 ";
         }
      
         return " ";
      }
   
   
      final public byte getEntitySize() {
         switch (Shoals.initial_type) {
            case Shoals._START_LARGE:
               return 39;
            
            case Shoals._START_MEDIUM:
               return 29;
            
            case Shoals._START_SMALL:
               return 21;
         }
      
         return 20;
      }
   
      final public void add() {
         Shoals_Input.addFromString(getCreatureDescription(),Shoals.entity_manager,0,0,128 + rnd.nextInt(128));
      }
   
   /*
      public Entity copy(Entity e) {
         // number_of_agents++;
         new_array_of_agents = new Entity[number_of_agents + 1];
      
         for (temp = 0; temp < number_of_agents; temp++) {
            new_array_of_agents[temp] = agent[temp];
         }
      
         new_array_of_agents[number_of_agents] = new Entity(e);
      
         agent = new_array_of_agents;
      
         return agent[number_of_agents++];
      }
   */
   
     // called on resize...
      final public void resetEntityGrid() {
         gcd = (general_eggsize + general_size + 4) << shift;
      
         temp = 12;
      
         while (gcd > (1 << temp)) {
            temp++;
         }
      
         entity_grid = new EntityGrid(temp);
      
         ensureEntitiesAreBinnedAgain();
      }
   
   
      final public void ensureEntitiesAreBinnedAgain() {
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].current_bin_x = -1;
            agent[temp].current_bin_y = -1;
         }
      
         for (temp = 0; temp < number_of_leaders; temp++) {
            ((Entity)leader[temp]).current_bin_x = -1;
            ((Entity)leader[temp]).current_bin_y = -1;
         }
      }
   
   
      final public void bufferedUpdate() {
         if (Shoals.use_links) {
            if (number_of_links > 0) {
               link_manager.scrubTheLinks();
               link_manager.exerciseTheLinks();
            }
         }
      
         if (number_of_leaders > 0) {
            scrubTheLeaders();
            if (!Shoals.paused) {
               travelTheLeaders();
            }
         }
      
         if (number_of_agents > 0) {
            scrubTheAgents();
            if (!Shoals.paused) {
               travelTheAgents();
            }
         }
      
         if (Shoals.use_links) {
            if (number_of_links > 0) {
               link_manager.drawTheLinks();
            }
         }
      
         apply_acceleration();
      
         if (number_of_leaders > 0) {
            drawTheLeaders();
         }
      
      
         if (number_of_agents > 0) {
            drawTheAgents();
         }
      
      
         if (Shoals.check_collisions) {
            if (!Shoals.paused) {
               collisionCheck();
            }
         }
      }
   
   
      final public void unbufferedAgentUpdate() {
         Entity.temp_private_world = this;
         if (Shoals.frame_frequency == 0) {
            if (number_of_agents > 0) {
               if ((Shoals.quality == Shoals._QUALITY_1) || (Shoals.quality == Shoals._QUALITY_2)) {
                  for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
                     Shoals_Grid.colourZero();
                     agent[agent_counter].scrub();
                  
                     if (!Shoals.paused) {
                        agent[agent_counter].travel();
                     }
                  
                     agent[agent_counter].draw();
                  }
               }
               else
               {
                  if (Shoals.quality == Shoals._QUALITY_3) {
                     for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
                        agent[agent_counter].scrub();
                     
                        if (!Shoals.paused) {
                           agent[agent_counter].travel();
                        }
                     
                        agent[agent_counter].draw();
                     }
                  }
                  else
                  {
                     {
                        for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
                           agent[agent_counter].scrub();
                        
                           if (!Shoals.paused) {
                              agent[agent_counter].travel();
                           }
                        
                           agent[agent_counter].draw();
                        }
                     }
                  }
               }
            }
         
            if (number_of_leaders > 0) {
               for (agent_counter = number_of_leaders; --agent_counter >= 0; ) {
               // for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
                  Shoals_Grid.colourZero();
                  leader[agent_counter].scrub();
               
                  if (!Shoals.paused) {
                     leader[agent_counter].travel();
                  }
               
                  leader[agent_counter].draw();
               }
            }
         
            if (Shoals.use_links) {
               if (number_of_links > 0) {
                  link_manager.linkUpdating();
               }
            }
         
            if (!Shoals.paused) {
               apply_acceleration();
               if (Shoals.check_collisions) {
                  collisionCheck();
               }
            }
         }
         else
         {
            if (number_of_agents > 0) {
               scrubTheAgents();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (!Shoals.paused) {
                  if (number_of_agents > 0) {
                     travelTheAgents();
                  }
               
                  if (Shoals.use_links) {
                     if (number_of_links > 0) {
                        link_manager.linkUpdating();
                     }
                  }
               
                  apply_acceleration();
                  if (Shoals.check_collisions) {
                     collisionCheck();
                  }
               }
            }
         
            if (number_of_agents > 0) {
               drawTheAgents();
            }
         
            if (number_of_leaders > 0) {
               scrubTheLeaders();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (!Shoals.paused) {
                  if (number_of_leaders > 0) {
                     travelTheLeaders();
                  }
               
                  if (Shoals.check_collisions) {
                     collisionCheck();
                  }
               }
            }
         
            if (number_of_leaders > 0) {
               drawTheLeaders();
            }
         }
      }
   
   
      final public void collisionCheckNbyN() {
         for (temp = 0; temp < (number_of_agents + number_of_leaders - 1); temp++) {
            setUpTempAgent();
            for (temp2 = temp + 1; temp2 < (number_of_agents + number_of_leaders); temp2++) {
               setUpTemp2Agent();
               collideTheseEntities();
            }
         }
      }
   
   
      final public void collisionCheck() {
         if (Shoals.oscd) {
            collisionCheckNbyN();
         }
         else
         {
            findNewBins();
         
            for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
               setUpTempAgent();
            
               new_bin_x = temp_agent.current_bin_x; //temp_agent.x >>> EntityGrid.log2binsize;
               new_bin_y = temp_agent.current_bin_y; //temp_agent.y >>> EntityGrid.log2binsize;
            
               // C
               list = entity_grid.entity_list[new_bin_x][new_bin_y];
               temp3 = list.getNumberInList(temp_agent) + 1;
               if (temp3 < list.current_number) {
                  for (temp2 = temp3; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                  
                     collideTheseEntities();
                  }
               }
            
               // W
               if (new_bin_x > 0) {
                  list = entity_grid.entity_list[new_bin_x - 1][new_bin_y];
                  for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                     collideTheseEntities();
                  }
               
               // NW
                  if (new_bin_y > 0) {
                     list = entity_grid.entity_list[new_bin_x - 1][new_bin_y - 1];
                     for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                        temp2_agent = list.entity[temp2];
                        collideTheseEntities();
                     }
                  }
               
               	// SW
                  if (new_bin_y < (EntityGrid.ny - 1)) {
                     list = entity_grid.entity_list[new_bin_x - 1][new_bin_y + 1];
                     for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                        temp2_agent = list.entity[temp2];
                        collideTheseEntities();
                     }
                  }
               }
            
               // U
               if (new_bin_y > 0) {
                  list = entity_grid.entity_list[new_bin_x][new_bin_y - 1];
                  for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                     collideTheseEntities();
                  }
               }
            }
         }
      }
   
   
      final public void setUpTempAgent() {
         if (temp < number_of_agents) {
            temp_agent = agent[temp];
         }
         else
         {
            temp_agent = (Entity)leader[temp - number_of_agents];
         }
      }
   
   
      final public void setUpTemp2Agent() {
         if (temp2 < number_of_agents) {
            temp2_agent = agent[temp2];
         }
         else
         {
            temp2_agent = (Entity)leader[temp2 - number_of_agents];
         }
      }
   
   
      final public void findNewBins() {
         for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
            setUpTempAgent();
         
            new_bin_x = temp_agent.x >>> EntityGrid.log2binsize;
            new_bin_y = temp_agent.y >>> EntityGrid.log2binsize;
         
            if (new_bin_x < 0) new_bin_x = 0;
            if (new_bin_y < 0) new_bin_y = 0;
         
            if ((temp_agent.current_bin_x != new_bin_x) || (temp_agent.current_bin_y != new_bin_y)) {
               EntityGrid.addToList(new_bin_x, new_bin_y, temp_agent);
               EntityGrid.removeFromList(temp_agent.current_bin_x, temp_agent.current_bin_y, temp_agent);
            
               temp_agent.current_bin_x = new_bin_x;
               temp_agent.current_bin_y = new_bin_y;
            }
         }
      }
   
   
      boolean sameSign(int a, int b) {
         return (((a ^ b) & 0x80000000) == 0);
      }
   
   
      final public void apply_acceleration() {
         // apply acceleration...
         if (number_of_agents > 0) {
            for (temp = 0; temp < number_of_agents; temp++) {
               temp_agent = agent[temp];
               if (!Shoals.gas_sim) {
                  if (number_of_leaders > 0) {
                  // turn about...
                  
                  // for (temp2 = 0; temp2 < number_of_leaders; temp2++) {
                     temp2 = 0;
                     // temp4 = temp_agent.x - ((Entity)leader[temp2]).x;
                     // temp5 = temp_agent.y - ((Entity)leader[temp2]).y;
                     temp_agent.preferred_direction = (byte)(arcTangent(temp_agent.x - ((Entity)leader[temp2]).x, temp_agent.y - ((Entity)leader[temp2]).y) + Entity.direction_bias);
                  
                     /*if ((temp4 < 0) && (temp5 < 0)) {
                        temp3 = rnd.nextInt();
                        if (temp4 < temp5) {
                           temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + Entity.direction_bias;
                        }
                        else
                        {
                           temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 4 + Entity.direction_bias;
                        }
                     }
                     else
                     {
                        if ((temp4 < 0) && (temp5 >= 0)) {
                           temp3 = rnd.nextInt();
                           if (-temp4 < temp5) {
                              temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 24 + Entity.direction_bias;
                           }
                           else
                           {
                              temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 28 + Entity.direction_bias;
                           }
                        }
                        else
                        {
                           if ((temp4 >= 0) && (temp5 < 0)) {
                              temp3 = rnd.nextInt();
                              if (temp4 < -temp5) {
                                 temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 8 + Entity.direction_bias;
                              }
                              else
                              {
                                 temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 12 + Entity.direction_bias;
                              }
                           }
                           else
                           {
                              if ((temp4 > 0) && (temp5 >= 0)) {
                                 temp3 = rnd.nextInt();
                                 if (temp4 > temp5) {
                                    temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 16 + Entity.direction_bias;
                                 }
                                 else
                                 {
                                    temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 20 + Entity.direction_bias;
                                 }
                              }
                           }
                        }
                     	*/
                  
                  // conditionally...
                     temp_agent.thrust(towards_leader);
                  }
               }
            
               temp_agent.dy += gravity;
            }
         }
      
         // apply acceleration to leader...
         if (!Shoals.gas_sim) {
            if (number_of_leaders > 0) {
               for (temp2 = 0; temp2 < number_of_leaders; temp2++) {
                  if (((Entity)leader[temp2]).x < (Shoals_Canvas.current_mouse_x)) {
                     ((Entity)leader[temp2]).dx += acc_of_leader;
                  }
                  else
                  {
                     if (((Entity)leader[temp2]).x > (Shoals_Canvas.current_mouse_x)) {
                        ((Entity)leader[temp2]).dx -= acc_of_leader;
                     }
                  }
               
                  if (((Entity)leader[temp2]).y < (Shoals_Canvas.current_mouse_y)) {
                     ((Entity)leader[temp2]).dy += acc_of_leader;
                  }
                  else
                  {
                     if (((Entity)leader[temp2]).y > (Shoals_Canvas.current_mouse_y)) {
                        ((Entity)leader[temp2]).dy -= acc_of_leader;
                     }
                  }
               
                  ((Entity)leader[temp2]).dy += gravity;
               }
            }
         }
      }
   
   
      final public byte arcTangent(int dx, int dy) {
         temp3 = rnd.nextInt();
         if ((dx < 0) && (dy < 0)) {
            if (dx < dy) {
               return (byte)((temp3 & 3) + (temp3 >>> 31));
            }
            else
            {
               return (byte)((temp3 & 3) + (temp3 >>> 31) + 4);
            }
         }
         else
         {
            if ((dx < 0) && (dy >= 0)) {
               if (-dx < dy) {
                  return (byte)((temp3 & 3) + (temp3 >>> 31) + 24);
               }
               else
               {
                  return (byte)(((temp3 & 3) + (temp3 >>> 31) + 28) & Entity.TRIG_TAB_SIZEMO);
               }
            }
            else
            {
               if ((dx >= 0) && (dy < 0)) {
                  if (dx < -dy) {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 8);
                  }
                  else
                  {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 12);
                  }
               }
               else
               {
                  //if ((dx > 0) && (dy >= 0)) {
                  if (dx > dy) {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 16);
                  }
                  else
                  {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 20);
                  }
                  // }
               }
            }
         }
      }
   
   
   // accepts temp_agent and temp2_agent
      final public void collideTheseEntities() {
         temp_detection_distance = (int)temp_agent.detection_radius + (int)temp2_agent.detection_radius; // get this outside the loop?
         temp_detection_distance2 = temp_detection_distance << shift;
         temp3 = temp_agent.x - temp2_agent.x;
         temp5 = (temp3 < 0) ? -temp3 : temp3; // hmmm...
         if (temp5 < temp_detection_distance2) {
            temp4 = temp_agent.y - temp2_agent.y;
            temp6 = (temp4 < 0) ? -temp4 : temp4;
            if (temp6 < temp_detection_distance2) {
               // probable collision...
               // outer diamond check...
               if ((((temp_detection_distance2) + (temp_detection_distance2 >> 1)) - temp5) > temp6) {
               
               // make smaller to prevent overflow...
                  tadx = (temp5 >> shift);
                  tady = (temp6 >> shift);
                  temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
                  // temp_detection_distance = temp_detection_distance >> shift;
                  temp_detection_distance_squared = temp_detection_distance * temp_detection_distance; // temp_detection_distance_squared; // temp_detection_distance * temp_detection_distance;
                  if (temp_radius < temp_detection_distance_squared) {
                     // collision 
                     // collide_with_self = ((temp_agent.creature == temp2_agent.creature) && (temp_agent.creature != null));
                     // sqrt - really? :-(
                     temp_radius = SquareRoot.sqrt(1 + temp_radius);
                  
                     // find unit vector along collision path...
                     temp_x = (temp3) / temp_radius; // unit vector * 65536
                     temp_y = (temp4) / temp_radius;
                  
                     // debug("temp_x:" + temp_x + " - temp_y:" + temp_y); // seems ok
                  
                     // compute the relative velocities...
                  
                     tadx = temp_agent.dx - temp2_agent.dx;
                     tady = temp_agent.dy - temp2_agent.dy;
                  
                  // dot product...
                     magnitude = -(((tadx * temp_x) + (tady * temp_y)) >> shift);
                     // magnitude = (magnitude < 0) ? -magnitude : magnitude;
                  
                     if (magnitude > 0) {
                        //if (collide_with_self) {
                        //temp_count = ((temp_detection_distance - temp_radius) << 6);
                        //}
                        //
                        //else
                     
                        temp_count = ((temp_detection_distance - temp_radius) << 8) + minimum_magnitude;
                        if (((temp_agent.status & Entity.DEADLY) != 0) && ((temp2_agent.status & Entity.IMMORTAL) == 0)) {
                           if ((temp2_agent.status & Entity.DEATH_MASK) == 0) {
                              creature_manager.infectCreature(temp2_agent, temp_agent);
                           }
                        } 
                        else
                        {
                           if (((temp2_agent.status & Entity.DEADLY) != 0) && ((temp_agent.status & Entity.IMMORTAL) == 0)) {
                              if ((temp_agent.status & Entity.DEATH_MASK) == 0) {
                                 creature_manager.infectCreature(temp_agent, temp2_agent);
                              }
                           }
                        }
                     
                        if (temp_count > maximum_magnitude) {
                           temp_count = maximum_magnitude;
                        }
                     
                     //if (magnitude <= 0) {
                        //magnitude = -magnitude; // temp_count;
                     //}
                     
                     
                        if (magnitude < temp_count) {
                           magnitude = temp_count;
                        }
                     
                        temp7 = temp_agent.numberOfLinks();
                        temp8 = temp2_agent.numberOfLinks();
                     
                        if ((temp7 > 0) || (temp8 > 0)) {
                           possiblyLink(temp_agent, temp2_agent);
                        
                           temp9 = temp7;
                           temp7 = temp8;
                           temp8 = temp9;
                        
                           possiblyLink(temp2_agent, temp_agent);
                        }
                     
                        // crude hack - since impulse calculations don't seem to be running yet...
                        temp_x = temp_x * magnitude;
                        temp_y = temp_y * magnitude;
                     
                        temp_ma = (temp_agent.log_mass - temp2_agent.log_mass);
                     
                        if (temp_ma < 0) {
                           tadx = temp_x >> -temp_ma;
                           tady = temp_y >> -temp_ma;
                        
                           temp_agent.dx += tadx >> 9;
                           temp_agent.dy += tady >> 9;
                           temp2_agent.dx -= ((temp_x << 1) - tadx) >> 9;
                           temp2_agent.dy -= ((temp_y << 1) - tady) >> 9;
                        }
                        else
                        {
                           tadx = temp_x >> temp_ma;
                           tady = temp_y >> temp_ma;
                        
                           temp_agent.dx += ((temp_x << 1) - tadx) >> 9;
                           temp_agent.dy += ((temp_y << 1) - tady) >> 9;
                           temp2_agent.dx -= tadx >> 9;
                           temp2_agent.dy -= tady >> 9;
                        }
                     }
                  
                     //}
                     //else // already moving apart from one another...
                     //{
                     //}
                  
                        //}
                        // }
                        /*else
                        {
                           temp_agent.dx += temp_x << 2;
                           temp_agent.dy += temp_y << 2;
                           temp2_agent.dx -= temp_x << 2;
                           temp2_agent.dy -= temp_y << 2;
                        }*/
                  
                           /*
                           if (tadx == 0) {
                           tadx = 1 << shift;
                           }
                           
                           if (tadx == 0) {
                           tadx = 1 << shift;
                           } */
                           /*
                           temp_count = 12;
                           
                           do {
                           temp_agent.x += (tadx >> 4);
                           temp_agent.y += (tady >> 4);
                           temp2_agent.x -= (tadx >> 4);
                           temp2_agent.y -= (tady >> 4);
                           
                           temp3 = temp_agent.x - temp2_agent.x;
                           temp5 = (temp3 < 0) ? -temp3 : temp3;
                           
                           temp4 = temp_agent.y - temp2_agent.y;
                           temp6 = (temp4 < 0) ? -temp4 : temp4;
                           
                           temp_radius = (temp5 * temp5) + (temp6 * temp6);  // now check using circle...
                           } while ((temp_radius < detection_radius_squared) && (temp_count-- > 0));
                           */
                  
                           /*
                           temp_agent.x += temp_agent.dx;
                           temp_agent.y += temp_agent.dy;
                           temp2_agent.x += temp2_agent.dx;
                           temp2_agent.y += temp2_agent.dy;
                           */
                  
                  }
               }
            }
         }
      }
   
   
      void possiblyLink(Entity e1, Entity e2) {
         if (e1 != null) {
            if (e2 != null) {
               if (e1.isEdge() && e2.isEdge()) {
                  if (temp7 == 0) {
                     if (e2.numberOfLinks() == 3) {
                        if (e2.numberOfLinksToColour((char)511) == 1) {
                           join(e1,e2);
                        }
                     }
                  }
               }
            
               if (e1.isEdge() && e2.isNonEdge()) {
                  if (temp7 == 1) {
                     if (temp8 > 2) { // == 4) || (temp8 == 5)) {
                        temp3_entity = e1.list_of_links.link[0].theOtherEnd(e1);
                        if (temp3_entity.isEdge()) {
                           if (temp3_entity.numberOfLinks() > 2) { // = 4
                              if (temp3_entity.isLinkedTo(e2)) {
                                 join(e1,e2);
                              }
                           }
                        }
                     }
                  }
                  else
                  {
                     if (temp7 == 2) {
                        if (temp8 == 1) {
                           temp3_entity = e2.list_of_links.link[0].theOtherEnd(e2);
                           if (temp3_entity.numberOfLinks() == 6) {
                              if (temp3_entity.isLinkedTo(e1)) {
                                 join(e1,e2);
                              }
                           }
                        }
                        else
                        { ////
                           if (temp8 == 2) {
                              if (e1.sharesANeighbourWith(e2)) {
                                 join(e1,e2);
                              }
                           /*
                              temp3_entity = e1.list_of_links.link[0].theOtherEnd(e1);
                              temp4_entity = e2.list_of_links.link[0].theOtherEnd(e2);
                              if (temp3_entity.isLinkedTo(temp4_entity)) {
                                 join(e1,e2);
                              }
                              else
                              {
                                 temp5_entity = e1.list_of_links.link[1].theOtherEnd(e1);
                                 if (temp5_entity.isLinkedTo(temp4_entity)) {
                                    join(e1,e2);
                                 }
                                 else
                                 {
                                    temp6_entity = e1.list_of_links.link[1].theOtherEnd(e1);
                                    if (temp6_entity.isLinkedTo(temp3_entity)) {
                                       join(e1,e2);
                                    }
                                    else
                                    {
                                       if (temp5_entity.isLinkedTo(temp6_entity)) {
                                          join(e1,e2);
                                       }
                                    }
                                 }
                              }
                           	*/
                           }
                        }
                     }
                  }
               }
            
               if (temp7 == 1) {
                  if ((temp8 > 2) && (temp8 < 5)) {
                     temp3_entity = e1.list_of_links.link[0].theOtherEnd(e1);
                     if (temp3_entity.isLinkedTo(e2)) {
                        if (temp3_entity.numberOfLinks() == 6) {
                           join(e1,e2);
                        }
                     }
                  }
               }
            
               if (e1.isNonEdge() && e2.isNonEdge()) {
                  if ((temp7 > 1) && (temp7 < 5)) {
                     if ((temp8 > 2) && (temp8 < 5)) {
                        temp3_entity = e1.findSharedNeighbourWith(e2); // npe?
                        if (temp3_entity != null) {
                           if (temp3_entity.numberOfLinks() == 6) {
                              join(e1,e2);
                           }
                        }
                     }
                  }
               
                  if ((e1.colour == e2.colour)) {
                     if (temp7 == 0) {
                        if (temp8 == 5) {
                           join(e1,e2);
                        }
                     }
                  }
               }
            }
         }
      }
   
   
      final public void join(Entity e1, Entity e2) {
         if ((e1.status & Entity.SOURCE) == 0) {
            if ((e2.status & Entity.SOURCE) == 0) {
               if (!e1.isLinkedTo(e2)) {
                  link_manager.setLink(e1, e2, general_size + 1, 160, 511, 0);
               }
            }
         }
      }
   
   
      final public Entity isThereOne2(int x, int y) {
         for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
            setUpTempAgent();
            temp_detection_distance = ((int)temp_agent.detection_radius) << shift;// + temp2_agent.detection_radius;
            temp3 = temp_agent.x - x;
            temp5 = (temp3 < 0) ? -temp3 : temp3;
            if (temp5 < temp_detection_distance) {
               temp4 = temp_agent.y - y;
               temp6 = (temp4 < 0) ? -temp4 : temp4;
               if (temp6 < temp_detection_distance) {
                  // probable collision...
                  // make smaller to prevent overflow...
                  tadx = (temp5 >> shift);
                  tady = (temp6 >> shift);
                  temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
                  temp_detection_distance_squared = temp_agent.detection_radius * temp_agent.detection_radius;
                  if (temp_radius < temp_detection_distance_squared) {
                     // collision 
                     return temp_agent;
                  }
               }
            }
         }
      
         return null;
      }
   
   
      final public Entity isThereOne(int x, int y) {
         if (Shoals.oscd) {
            return isThereOne2(x,y);
         }
         else
         {
            new_bin_x = x >>> EntityGrid.log2binsize;
            new_bin_y = y >>> EntityGrid.log2binsize;
         
            if (new_bin_x < 0) 
               new_bin_x = 0;
         
            if (new_bin_x >= EntityGrid.nx) 
               new_bin_x = EntityGrid.nx - 1;
         
            if (new_bin_y < 0) 
               new_bin_y = 0;
         
            if (new_bin_y >= EntityGrid.ny) 
               new_bin_y = EntityGrid.ny - 1;
         
            list = entity_grid.entity_list[new_bin_x][new_bin_y];
         
            temp_agent = checkThisList(x, y);
            if (temp_agent != null) {
               return temp_agent;
            }
         
            if (new_bin_x > 0) {
               list = entity_grid.entity_list[new_bin_x - 1][new_bin_y];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            
               if (new_bin_y > 0) {
                  list = entity_grid.entity_list[new_bin_x - 1][new_bin_y - 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            
               if (new_bin_y < (EntityGrid.ny - 1)) {
                  list = entity_grid.entity_list[new_bin_x - 1][new_bin_y + 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            }
         
            if (new_bin_x < (EntityGrid.nx - 1)) {
               list = entity_grid.entity_list[new_bin_x + 1][new_bin_y];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            
               if (new_bin_y > 0) {
                  list = entity_grid.entity_list[new_bin_x + 1][new_bin_y - 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            
               if (new_bin_y < (EntityGrid.ny - 1)) {
                  list = entity_grid.entity_list[new_bin_x + 1][new_bin_y + 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            }
         
            // D
            if (new_bin_y > 0) {
               list = entity_grid.entity_list[new_bin_x][new_bin_y - 1];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            }
         
         	// U
            if (new_bin_y < (EntityGrid.ny - 1)) {
               list = entity_grid.entity_list[new_bin_x][new_bin_y + 1];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            }
         }
      
         return null;
      }
   
   
      Entity checkThisList(int x, int y) {
         for (temp = 0; temp < list.current_number; temp++) {
            temp_agent = list.entity[temp];
            temp_detection_distance = ((int)temp_agent.detection_radius) << shift;
            temp3 = temp_agent.x - x;
            temp5 = (temp3 < 0) ? -temp3 : temp3;
            if (temp5 < temp_detection_distance) {
               temp4 = temp_agent.y - y;
               temp6 = (temp4 < 0) ? -temp4 : temp4;
               if (temp6 < temp_detection_distance) {
                  // probable collision...
                  // make smaller to prevent overflow...
                  tadx = (temp5 >> shift);
                  tady = (temp6 >> shift);
                  temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
                  temp_detection_distance_squared = temp_agent.detection_radius * temp_agent.detection_radius;
                  // emp_detection_distance_squared *= temp_detection_distance_squared; // temp_detection_distance * temp_detection_distance;
                  if (temp_radius < temp_detection_distance_squared) {
                     // collision 
                     return temp_agent;
                  }
               }
            }
         }
      
         return null;
      }
   
   
      final void drawTheAgents() {
         Shoals_Grid.last_colour = -1;
         // Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
            agent[agent_counter].draw();
         }
      }
   
   
      final void scrubTheAgents() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
            agent[agent_counter].scrub();
         }
      }
   
   
      final void travelTheAgents() {
         Entity.temp_private_world = this;
         // for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
         for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
            agent[agent_counter].travel();
         }
      }
   
   
      final void drawTheLeaders() {
         Shoals_Grid.last_colour = -1;
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].draw();
         }
      }
   
   
      final void travelTheLeaders() {
         Entity.temp_private_world = this;
         // for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
         for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
            leader[agent_counter].travel();
         }
      }
   
   
      final void scrubTheLeaders() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].scrub();
         }
      }
   
   
      public void setGlobalSize(byte d) {
         general_size = d;
      
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].setInitialSize(d,d);
         }
      
         for (temp = 0; temp < Entity.TRIG_TAB_SIZE; temp++) {
            Entity.ship_image_array[temp] = null;
         }
      }
   
   
      public void setGlobalEggSize(byte d) {
         general_eggsize = d;
      
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].setInitialSize(d,d);
         }
      
         Entity.ring_image = null;
      }
   
   
      final void changeNumber() {
         if ((target_number_of_agents != number_of_agents)) {
            while (target_number_of_agents > number_of_agents) {
               addNewAgent();
            }
         
            while (target_number_of_agents < number_of_agents) {
               killAgent();
            }
         
            resetEntityGrid();
         }
      }
   
   
      final void changeLeaderNumber() {
         if ((target_number_of_leaders != number_of_leaders)) {
            while (target_number_of_leaders > number_of_leaders) {
               addNewLeader();
            }
         
            while (target_number_of_leaders < number_of_leaders) {
               killLeader();
            }
         
            resetEntityGrid();
         }
      }
   
   
      // wastes memory, but who cares?
      final void addNewLeader() {
         number_of_leaders++;
      
         new_array_of_leaders = new Entity_Leader[number_of_leaders];
      
         for (temp = 0; temp < (number_of_leaders - 1); temp++) {
            new_array_of_leaders[temp] = leader[temp];
         }
      
         if (number_of_leaders > 1) {
            temp = rnd.nextInt(number_of_leaders - 1);
            temp_x = ((Entity)leader[temp]).x + rnd.nextInt(256);
            temp_y = ((Entity)leader[temp]).y + rnd.nextInt(256);
         
            new_array_of_leaders[number_of_leaders - 1] = new Entity_Leader(temp_x, temp_y, rnd.nextInt());
            ((Entity)new_array_of_leaders[number_of_leaders - 1]).colour = ((Entity)leader[temp]).colour;
            ((Entity)new_array_of_leaders[number_of_leaders - 1]).setSize((byte)(((Entity)leader[temp]).diameter));
         }
         else
         {
            temp_x = rnd.nextInt(Shoals_Canvas.gsx) << shift;
            temp_y = rnd.nextInt(Shoals_Canvas.gsy) << shift;
         
            new_array_of_leaders[number_of_leaders - 1] = new Entity_Leader(temp_x, temp_y, rnd.nextInt());
         }
      
         leader = new_array_of_leaders;
      }
   
   
      final void killAgent() {
         if (number_of_agents > 0) {
            killNumberedAgent(number_of_agents - 1);
            // link_manager.killAllLinks(agent[number_of_agents - 1]);
            // number_of_agents--;
         }
      }
   
   
      final boolean killThisEntity(Entity e) {
         for (temp = 0; temp < number_of_agents; temp++) {
            if (agent[temp] == e) {
               killNumberedAgent(temp);
               return true;
            }
         }
      
         for (temp = 0; temp < (number_of_leaders); temp++) {
            if ((Entity)leader[temp] == e) {
               killNumberedLeader(temp);
               return true;
            }
         }
      
         return false;
      }
   
   
      final void killNumberedAgent(int n) {
         temp_agent = agent[n];
         temp_agent.scrub();
         link_manager.killAllLinks(temp_agent);
      
         agent[n] = agent[number_of_agents - 1];
         agent[--number_of_agents] = temp_agent;
      
         // IMPORTANT: remove it from the bins...
         temp_agent.removeFromBin();
      }
   
   
      final void killNumberedLeader(int n) {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         leader[n].scrub();
         link_manager.killAllLinks(leader[n]);
         temp_leader = leader[n];
         leader[n] = leader[number_of_leaders - 1];
         leader[--number_of_leaders] = temp_leader;
      }
   
   
      final void killLeader() {
         number_of_leaders--;
      }
   
   
      // returns distance in pixels...
      final int distanceBetween(Entity e1, Entity e2) {
         temp2 = (e1.x - e2.x) >> shift;
         temp3 = (e1.y - e2.y) >> shift;
         temp_radius = temp2 * temp2 + temp3 * temp3;
      
         return SquareRoot.sqrt(temp_radius);
      }
   
   
      final Entity getSelectedEntity() {
         for (temp = 0; temp < (number_of_agents); temp++) {
            if ((agent[temp].status & Entity.SELECTED) != 0) {
               return agent[temp];
            }
         }
      
         return null;
      }
   
   
      final void deselectAll() {
         for (temp = 0; temp < (number_of_agents); temp++) {
            if ((agent[temp].status & Entity.SELECTED) != 0) {
               agent[temp].scrub();
               agent[temp].status &= (-1 ^ Entity.SELECTED);
            }
         }
      }
   
   
      final void deleteSelected() {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               Shoals.killAllLinks(temp_agent);
               killThisEntity(temp_agent);
               temp2--;
            }
         }
      }
   
   
      final void setColourOfSelected(int c) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.colour = (char)c;
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      final void setSizeOfSelected(byte s) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.setInitialSize(s,s);
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      final void affectStatusBits(int and, int xor) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.status = (temp_agent.status & and) ^ xor;
               // Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
   
      final void moveSelection(int _dx, int _dy) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.x += _dx;
               temp_agent.y += _dy;
               temp_agent.dx = 0;
               temp_agent.dy = 0;
            
               temp_agent.boundaryCheck();
            
               // make sure bins are updated...
               temp_agent.findNewBin();
            }
         }
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
